#include <vcl.h>
#pragma hdrstop

#include "D2XXEvStatus.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TD2XXStatusEventThread::TD2XXStatusEventThread(TD2XXDriver *D2XXDriver) : TThread(false)
{
  FD2XXDriver = D2XXDriver;
}

//---------------------------------------------------------------------------
void __fastcall TD2XXStatusEventThread::Execute()
{
  while( !Terminated ){
    if( WaitForSingleObject(FD2XXDriver->seEvent, INFINITE) != WAIT_OBJECT_0 )  continue;
    Synchronize( DoOnSignal );
    // DoOnSignal();
  }
}

//---------------------------------------------------------------------------
void __fastcall TD2XXStatusEventThread::DoOnSignal(void)
{
  DWORD Status = FD2XXDriver->Status;
  if( Status & EV_CTS     )  if( FD2XXDriver->OnCTSSignal     )  FD2XXDriver->OnCTSSignal(FD2XXDriver);
  if( Status & EV_RLSD    )  if( FD2XXDriver->OnDCDSignal     )  FD2XXDriver->OnDCDSignal(FD2XXDriver);
  if( Status & EV_DSR     )  if( FD2XXDriver->OnDSRSignal     )  FD2XXDriver->OnDSRSignal(FD2XXDriver);
  if( Status & EV_RING    )  if( FD2XXDriver->OnRingSignal    )  FD2XXDriver->OnRingSignal(FD2XXDriver);
  if( Status & EV_RXCHAR  )  if( FD2XXDriver->OnRxDSignal     )  FD2XXDriver->OnRxDSignal(FD2XXDriver);
  if( Status & EV_RXFLAG  )  if( FD2XXDriver->OnRxEventSignal )  FD2XXDriver->OnRxEventSignal(FD2XXDriver);
  if( Status & EV_TXEMPTY )  if( FD2XXDriver->OnTxDSignal     )  FD2XXDriver->OnTxDSignal(FD2XXDriver);
  if( Status & EV_BREAK   )  if( FD2XXDriver->OnBreakSignal   )  FD2XXDriver->OnBreakSignal(FD2XXDriver);
  if( Status & EV_ERR     )  if( FD2XXDriver->OnErrorSignal   )  FD2XXDriver->OnErrorSignal(FD2XXDriver, GetLastError() );

/*
Errorflags for OnErrorSignal

 CE_BREAK       The hardware detected a break condition.
 CE_DNS	        Windows 95 only: A parallel device is not selected.
 CE_FRAME       The hardware detected a framing error.
 CE_IOE	        An I/O error occurred during communications with the device.
 CE_MODE        The requested mode is not supported, or the hFile parameter
                is invalid. If this value is specified, it is the only valid error.
 CE_OOP	        Windows 95 only: A parallel device signaled that it is out of paper.
 CE_OVERRUN     A character-buffer overrun has occurred. The next character is lost.
 CE_PTO	        Windows 95 only: A time-out occurred on a parallel device.
 CE_RXOVER      An input buffer overflow has occurred. There is either no
                room in the input buffer, or a character was received after
                the end-of-file (EOF) character.
 CE_RXPARITY    The hardware detected a parity error.
 CE_TXFULL      The application tried to transmit a character, but the output
                buffer was full.
 */
}

//---------------------------------------------------------------------------

