//---------------------------------------------------------------------------
// Copyright (C) 2005 by Chernov Sergey
// klen_s@mail.ru
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "D2XXThRead.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TD2XXReadThread::TD2XXReadThread(TD2XXDriver *D2XXDriver) : TThread(false)
{
  FD2XXDriver = D2XXDriver;
  FHandle = FD2XXDriver->Handle;
  ZeroMemory( &ROL, sizeof(ROL) );
  ROL.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
}

//---------------------------------------------------------------------------
__fastcall TD2XXReadThread::~TD2XXReadThread(void)
{
  CloseHandle( ROL.hEvent );
}

//---------------------------------------------------------------------------
void __fastcall TD2XXReadThread::Execute()
{
  while( !Terminated ){
    if( WaitForSingleObject(FD2XXDriver->rtEvent, INFINITE) != WAIT_OBJECT_0 )  continue;

    FTCOMSTAT lpStat;
    DWORD lpErrors;

    while( true ){
      FT_W32_ClearCommError( FHandle, &lpErrors, &lpStat );

      EnterCriticalSection( &FD2XXDriver->ReadSection );
      DWORD pos1 = FD2XXDriver->IBuffPos;
      DWORD used = FD2XXDriver->IBuffUsed;
      LeaveCriticalSection(&FD2XXDriver->ReadSection);

      DWORD pos2 = pos1 + used;
      DWORD size;
      if( pos2 < FD2XXDriver->IBuffSize ){
        size = FD2XXDriver->IBuffSize - pos2;
      }else{
        pos2 -= FD2XXDriver->IBuffSize;
        size = pos1 - pos2;
      }
      if( size > lpStat.cbInQue )  size = lpStat.cbInQue;

      if( size == 0 )  break;

      DWORD BytesReaded = 0;
      bool OK = FT_W32_ReadFile( FHandle, &(FD2XXDriver->IBuffer[pos2]), size, &BytesReaded, &ROL);
      if( !OK && GetLastError() == ERROR_IO_PENDING ){
        OK = FT_W32_GetOverlappedResult(FHandle, &ROL, &BytesReaded, TRUE);
        if( OK )  ResetEvent(ROL.hEvent);
      }
      if( OK && BytesReaded > 0 ){
        FD2XXDriver->IBuffUsed += BytesReaded;
        SetEvent(FD2XXDriver->reEvent);
      }
    }

  }
}

//---------------------------------------------------------------------------

