//---------------------------------------------------------------------------
// Copyright (C) 2005 by Chernov Sergey
// klen_s@mail.ru
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "D2XXThStatus.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TD2XXStatusThread::TD2XXStatusThread(TD2XXDriver *D2XXDriver, TComEventType Events) : TThread(false)
{
  DWORD EvList[9] = {EV_RXCHAR,
                     EV_RXFLAG,
                     EV_TXEMPTY,
                     EV_CTS,
                     EV_DSR,
                     EV_RLSD,
                     EV_BREAK,
                     EV_ERR,
                     EV_RING };

  FD2XXDriver = D2XXDriver;
  FHandle = FD2XXDriver->Handle;
  DWORD AttrWord = 0;

  for( int i=0; i < 9; i++ ){
    TEventState EvIndex = (TEventState)i;
    if( Events.Contains(EvIndex) )  AttrWord |= EvList[i];
  }

  FT_W32_SetCommMask( FHandle , AttrWord );

  ZeroMemory( &SOL, sizeof(SOL) );
  SOL.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
}

//---------------------------------------------------------------------------
__fastcall TD2XXStatusThread::~TD2XXStatusThread(void)
{
  CloseHandle( SOL.hEvent );
}

//---------------------------------------------------------------------------
void __fastcall TD2XXStatusThread::Execute()
{
  DWORD lpModemStatus;

  if( FD2XXDriver->IsEnabled() && FT_W32_GetCommModemStatus( FHandle, &lpModemStatus) ){
    FD2XXDriver->FCTS  = (lpModemStatus & MS_CTS_ON);
    FD2XXDriver->FDSR  = (lpModemStatus & MS_DSR_ON);
    FD2XXDriver->FDCD  = (lpModemStatus & MS_RLSD_ON);
    FD2XXDriver->FRing = (lpModemStatus & MS_RING_ON);
    FD2XXDriver->Status = 0;
  }

  while( !Terminated ){
    if( !FD2XXDriver->IsEnabled() )  continue;
    DWORD Status;
    bool OK = FT_W32_WaitCommEvent(FHandle, &Status, &SOL);
    if( !OK ){
      Sleep( 50 );
      if(GetLastError() == ERROR_IO_PENDING ){
        DWORD Temp;
        OK =  FT_W32_GetOverlappedResult(FHandle, &SOL, &Temp, TRUE );
        if( OK )  ResetEvent(SOL.hEvent);
      }
    }

    if( OK ){
      FD2XXDriver->Status = Status;

      if( (Status & (EV_CTS | EV_DSR | EV_RING | EV_RLSD | EV_ERR)) != 0 &&
        FT_W32_GetCommModemStatus(FHandle, &lpModemStatus) ){
        FD2XXDriver->FCTS = (lpModemStatus & MS_CTS_ON);
        FD2XXDriver->FDSR = (lpModemStatus & MS_DSR_ON);
        FD2XXDriver->FDCD = (lpModemStatus & MS_RLSD_ON);
        FD2XXDriver->FRing = (lpModemStatus & MS_RING_ON);

        if( FD2XXDriver->Control == ccHard &&
            FD2XXDriver->FCTS &&
            FD2XXDriver->OBuffUsed > 0 )  SetEvent(FD2XXDriver->wtEvent);
      }

      if( (Status & EV_RXCHAR) != 0 )  SetEvent(FD2XXDriver->rtEvent);

      SetEvent(FD2XXDriver->seEvent);
    }
  }
}

//---------------------------------------------------------------------------

