
#include <vcl.h>
#pragma hdrstop

#include "D2XXThWrite.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TD2XXWriteThread::TD2XXWriteThread( TD2XXDriver *D2XXDriver ) : TThread(false)
{
  FD2XXDriver = D2XXDriver;
  FHandle = FD2XXDriver->Handle;
  ZeroMemory( &WOL, sizeof(WOL) );
  WOL.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
}

//---------------------------------------------------------------------------
__fastcall TD2XXWriteThread::~TD2XXWriteThread(void)
{
  CloseHandle( WOL.hEvent );
}

//---------------------------------------------------------------------------
void __fastcall TD2XXWriteThread::Execute()
{
  while( !Terminated ){
    if( WaitForSingleObject(FD2XXDriver->wtEvent, INFINITE) != WAIT_OBJECT_0 )  continue;

    if( FD2XXDriver->OBuffUsed == 0 ){
      ResetEvent(FD2XXDriver->wtEvent);
      continue;
    }

    if( FD2XXDriver->Control == ccHard && !FD2XXDriver->CTS )  continue;

    FTCOMSTAT lpStat;
    DWORD lpErrors;
    FT_W32_ClearCommError( FHandle, &lpErrors, &lpStat );

    while( FD2XXDriver->OBuffUsed ){
      EnterCriticalSection( &FD2XXDriver->WriteSection );
      DWORD pos1 = FD2XXDriver->OBuffPos;
      DWORD used = FD2XXDriver->OBuffUsed;
      LeaveCriticalSection( &FD2XXDriver->WriteSection );

      DWORD pos2 = pos1 + used;
      DWORD size;
      if( pos2 < FD2XXDriver->OBuffSize ){
        size = pos2 - pos1;
      }else{
        pos2 -= FD2XXDriver->OBuffSize;
        size = FD2XXDriver->OBuffSize - pos1;
      }
      DWORD BytesWritten = 0;
      bool OK = FT_W32_WriteFile( FHandle, &(FD2XXDriver->OBuffer[pos1]), size, &BytesWritten, &WOL);
      if( !OK && GetLastError() == ERROR_IO_PENDING ){
        OK = FT_W32_GetOverlappedResult( FHandle, &WOL, &BytesWritten, TRUE);
        if( OK )  ResetEvent(WOL.hEvent);
      }
      if( OK ){
        EnterCriticalSection( &FD2XXDriver->WriteSection );
        FD2XXDriver->OBuffUsed -= BytesWritten;
        FD2XXDriver->OBuffPos += BytesWritten;
        if( FD2XXDriver->OBuffPos >= FD2XXDriver->OBuffSize )
            FD2XXDriver->OBuffPos -= FD2XXDriver->OBuffSize;
        LeaveCriticalSection( &FD2XXDriver->WriteSection );
      }
    }

  }
}

//---------------------------------------------------------------------------

